# This file automatically generated by skymarshal
# DO NOT MODIFY BY HAND
# fmt: off
# isort: off
# mypy: disallow-untyped-defs

import copy
import typing as T  # pylint: disable=unused-import

from io import BytesIO
import struct

class VectorXi(object):
    __slots__ = ["rows", "data"]  # type: T.List[str]

    def __init__(
        self,
        rows=0,  # type: int
        data=None,  # type: T.Sequence[int]
        _skip_initialize=False,  # type: bool
    ):
        # type: (...) -> None
        """ If _skip_initialize is True, all other constructor arguments are ignored """
        if _skip_initialize:
            return
        self.rows = rows
        self.data = [] if data is None else data  # type: T.Sequence[int]

    @staticmethod
    def from_all_fields(
        rows,  # type: int
        data,  # type: T.Sequence[int]
    ):
        # type: (...) -> VectorXi
        return VectorXi(
            rows=rows,
            data=data,
        )

    @staticmethod
    def _skytype_meta():
        # type: () -> T.Dict[str, str]
        return dict(
            type="struct",
            package="eigen_lcm",
            name="VectorXi",
        )

    @classmethod
    def _default(cls):
        # type: () -> VectorXi
        return cls()

    def __repr__(self):
        # type: () -> str
        return "VectorXi({})".format(
            ", ".join("{}={}".format(name, repr(getattr(self, name))) for name in self.__slots__))

    def __eq__(self, other):
        # type: (object) -> bool
        if not isinstance(other, VectorXi):
            return NotImplemented
        return (
            (self.rows==other.rows) and
            (self.data==other.data)
        )
    # Disallow hashing for python struct lcmtypes.
    __hash__ = None  # type: ignore

    def encode(self):
        # type: () -> bytes
        buf = BytesIO()
        buf.write(VectorXi._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        # type: (T.BinaryIO) -> None
        buf.write(VectorXi._CACHED_STRUCT_0.pack(self.rows))
        buf.write(struct.pack('>%di' % self.rows, *self.data[:self.rows]))

    @staticmethod
    def decode(data):
        # type: (T.Union[bytes, T.BinaryIO]) -> VectorXi
        # NOTE(eric): This function can technically accept either a BinaryIO or
        # anything that supports the C++ Buffer Protocol,
        # which is unspecifiable in type hints.

        if hasattr(data, "read"):
            # NOTE(eric): mypy isn't able to figure out the hasattr check
            buf = T.cast(T.BinaryIO, data)
        else:
            buf = BytesIO(T.cast(bytes, data))

        if buf.read(8) != VectorXi._get_packed_fingerprint():
            raise ValueError("Decode error")
        return VectorXi._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        # type: (T.BinaryIO) -> VectorXi
        self = VectorXi(_skip_initialize=True)
        self.rows = VectorXi._CACHED_STRUCT_0.unpack(buf.read(4))[0]
        self.data = struct.unpack('>%di' % self.rows, buf.read(self.rows * 4))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        # type: (T.List[T.Type]) -> int
        if VectorXi in parents: return 0
        tmphash = (0x9347b9a23a82b6c5) & 0xffffffffffffffff
        tmphash = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash

    _packed_fingerprint = None  # type: T.Optional[bytes]

    @staticmethod
    def _get_packed_fingerprint():
        # type: () -> bytes
        if VectorXi._packed_fingerprint is None:
            VectorXi._packed_fingerprint = struct.pack(">Q", VectorXi._get_hash_recursive([]))
        return VectorXi._packed_fingerprint

    def deepcopy(self, **kwargs):
        # type: (**T.Any) -> VectorXi
        """
        Deep copy of this LCM type

        Returns a copy w/ members specified by kwargs replaced with new values specified by kwargs.
        """
        result = copy.deepcopy(self)
        for key in kwargs:
            if not hasattr(result, key):
                raise KeyError("Type VectorXi does not have attribute: " + str(key))
            setattr(result, key, kwargs[key])
        return result

    _CACHED_STRUCT_0 = struct.Struct(">i")
